*******************************************************************************
*
*               Welcome to warp speed!
*
*               © 1997/98 HAAGE&PARTNER Computer GmbH
*
*               powerpc.library/WarpOS history
*
*               milestones:
*               V8.0  - first internal release of WarpOS. powerpc.library is
*                       running under WarpOS from now on.
*               V9.0  - PPC native memory management / exception handler
*                       support
*               V10.0 - MMU + BAT support implemented / PPC-Enforcer
*                       Reincarnation of VOXELSPACE
*               V11.0 - Virtual signal system / native msg handling
*               V12.0 - Memory protection support / InterCPU msg handling
*                       CyberStormPPC support
*               ***  Official Release  ***
*               V13.0 - Debugger support / Demos equipped with window support
*
*******************************************************************************

 4. 6.97        - first internal release
                - V8.0

 5. 6.97        - new memory management, based on mempools, inserted
                  (old implementation linked to exec/AllocVec disabled)

                  Thanks a lot to Michael Rock for the implementation of
                  this memory management!
                - V8.1

 7. 6.97        - New memory management routines locked by semaphores
                - OpenLibrary patch implemented to prevent WarpOS from
                  being killed by ELF applications.
                - New mirror tasks now get the priority of its partner
                  task instead of 0.
                - New library functions 'Super' and 'User' to switch
                  between supervisor and user mode.
                - New library function 'SetHardware' to affect some
                  CPU related resources (i.e. trace mode)
                - V8.2

 8. 6.97        - If no tasks are running/ready, the PPC enters a
                  power saving mode (nap mode)
                - New library function 'ModifyFPExc' allows to set/clear
                  the exception enable bits in the FPSCR to enable/disable
                  particular FP exceptions
                - New flag for CreateTaskPPC: TASKATTR_MOTHERPRI. Allows
                  child tasks to inherit the priority of the mother task
                - New tools to set/clear global breakpoints: ibreak and
                  dbreak (dbreak only for 604[e])

 9. 6.97        - Priority of WarpOS system task 'Enterprise' changed to 1
                - New library functions 'SetExcHandler' and 'RemExcHandler'
                  allow to insert/remove custom exception handler (comparable
                  to exec/AddIntServer)
                - New memory management system temporarly disabled because of
                  linker problems.
                - V9.0

11. 6.97        - New memory management system re-enabled.

12. 6.97        - Signal numbers changed from BYTE to LONG (AllocSignalPPC,
                  FreeSignalPPC)
                - Emulation of misaligned FP accesses done (implemented in
                  warp.library). Author of the emulation: M.Rock.

13. 6.97        - Heavy bug fixed: Sleep routine (executed if no tasks
                  are running/ready) trashed the stack of a waiting task.
                - New library function 'WaitTime' allows to wait for a
                  given time or for given signals.
                - Emulation of DCBZ to noncachable/writethrough locations
                  implemented (warp.library)
                - V9.1

14. 6.97        - New WarpOS support task 'Voyager' implemented which frees
                  all memory allocated at 'CreateTaskPPC' if the task is
                  removed.
                - New *private* library function 'ChangeStack' to change the
                  PPC stack.
                - New tool 'stackppc' which works the same as the 'stack'
                  command (using 'ChangeTask').
                - Bug fixed: mirror tasks didn't get double the stack size
                  of the calling 68K process (as intended) because the
                  field 'pr_Stacksize' isn't updated by the Shell when
                  launching programs. The difference of TC_SPUPPER and
                  TC_SPLOWER multiplied by 2 is taken now.
                - New library functions 'LockTaskList' and 'UnLockTaskList'
                  allow to gain access to a list of all tasks.
                - New tool 'showtasks' prints out informations about all PPC
                  tasks.
                - V9.2

15. 6.97        - signal bit definition for SIGF_TIME changed from 2 to 9
                  to avoid collisions with exec signals.
                - paged MMU setup implemented and activated
                - exception handlers are now called with MMU switched off.
                  -> no critical locations like custom chip area (which must
                  be accessed in noncachable mode) must be accessed anymore
                - new library functions 'SetExcMMU' and 'ClearExcMMU' allow
                  to setup a temporary BAT based MMU setup in exception
                  handling code to access critical locations as described
                  above.

16. 6.97        - BAT support done. The BAT registers are now a local resource
                  of each task (like the normal registers) and they are
                  switched by the scheduler.
                - New library function 'ChangeMMU' allows to change the MMU
                  setup of the current task to standard or to BAT setup.
                - New tool 'changeMMU' performs the same action as the
                  library function, but it can be controlled from the shell.

17. 6.97        - bug fixed: mempools were not freed by mistake
                - MMU support for AllocVecPPC/FreeVecPPC implemented

18. 6.97        - ******  Reincarnation of VOXELSPACE !!  *******
                  the executable 'voxelspace' is now located in the demos
                  drawer. To run the demo a separate archive is required.
                  (voxel.lha). Welcome to warp speed! :)
                - PPC-Enforcer activated. First page is protected and all
                  accesses to $400-$1000 are emulated. Load accesses to $4
                  are emulated, too.
                - New library function 'GetInfo' allows to get many PPC
                  related information
                - New tool 'showinfo' displays all information currently
                  available by 'GetInfo'
                - V10.0

22. 6.97        - bug fixed: if someone tried to open powerpc.library with
                  too high version number, the powerpc.library was shut down.

23. 6.97        - SIGF_TIME changed again (Bit 10)

25. 6.97        - bug fixed which could cause deadlock at 68K-Calls
                - bug fixed: internal instruction cache flush was broken
                - signals are now completely transparent to the CPU's. All
                  signals are transferred at Cross-Calls -> A PPC task can
                  now be signaled by signaling its 68K mirror task and vice
                  versa. All signal bits are mirrored.

26. 6.97        - LN_TYPE field of a ppc task changed from NT_TASK to
                  NT_PPCTASK (-> tasksppc.i)
                - The whole signal handling is now based on the 'virtual
                  signal-pool'. Both CPU's share the signals and they can
                  signal tasks on both CPU's directly (i.e. a PPC-Task can
                  be signaled from 68K using exec/Signal with the PPCTask
                  structure as first argument).
                - Now it's safe not to restore the nonvolatile registers if
                  a PPC task exits by a single 'blr'. The smalldata base is
                  now automatically transferred to an alternative exit
                  routine, if one was specified at 'CreateTaskPPC'.
                - V10.1

27. 6.97        - New library functions implemented for Message-Handling:
                  CreateMsgPortPPC, DeleteMsgPortPPC, AddPortPPC, RemPortPPC,
                  FindPortPPC, WaitPortPPC, PutMsgPPC, GetMsgPPC, ReplyMsgPPC

28. 6.97        - A new PPC task now creates immediately a mirror 68K process
                  if none exists.

29. 6.97        - PutMsgPPC/ReplyMsgPPC can now be called from exception
                  handlers.
                - V10.2

13. 7.97        - New library function 'FreeAllMem' allows to free all
                  allocations made by the calling task.

15. 7.97        - If WarpOS is launched before ENV: is ready, then the
                  env variables are read a second time, when the first
                  RunPPC is performed (except for powerpc/debug)

16. 7.97        - WarpOS-Documentation in AMIGAGuide-Format done (D)

18. 7.97        - Dokumentation for Game-Development 'GameDev.guide'
                  included in archive (D)
                - V11.0

19. 7.97        - There was a tiny chance of problems with messages
                  sent from exception handling code -> fixed

20. 7.97        - Memory protection support implemented. Two new memory
                  attributes for 'AllocVecPPC' allow to allocate memory,
                  which is protected against other tasks (either full
                  protected or write protected).
                - The tool 'showtasks' now displays the pagetable of each
                  task.
                - The PPC-Code of the powerpc.library is now write-protected.
                - V11.1

21. 7.97        - New library function 'CopyMemPPC' to copy memory areas.
                - New environment variable 'powerpc/memprot' allows to
                  disable/enable the memory protection feature.
                - New 68K library functions 'AllocVec32' and 'FreeVec32'
                  allow to allocate memory which can be shared with PPC tasks
                - New 68K library function 'SPrintF68K' allows to print
                  debug information to the serial port/sushi.

22. 7.97        - cache flush optimization for 68040/68060 didn't work at all
                  -> fixed -> calling overhead decreased by 20 percent
                - InterCPU message handling implemented. New library functions
                  'AllocXMsg', 'FreeXMsg' and 'PutXMsg' for 68K to alloc
                  special InterCPU-Messages and to send them. New library
                  functions 'AllocXMsgPPC', 'FreeXMsgPPC' and 'PutXMsgPPC' do
                  the same for PPC.

23. 7.97        - Various bugs related to MMU features fixed
                - C-Includes added to the WarpOS-Archive.
                - V11.2

 1. 8.97        - Changed the assembler macros RUNPOWERPC and RUNPOWERPC_XL
                  (powerpc.i) to support direct PPC-Library-Calls from 68K-
                  Functions. Note: the parameters 2-4 were shifted to the
                  right by one. New parameter 2: The Library-Offset (used
                  in the same way like in the macros RUN68K and RUN68K_XL).
                - All include files were equipped with checks to the
                  constant POWERPCLIB_V7. If this symbol is defined then
                  no structures/macros are assembled, which can only be used
                  with powerpc.library V8+.
                - Added include file 'libraries/powerpc.i'. Including this
                  file sets the constant mentioned above and allows to create
                  V7-compatible applications.
                - Added the powerpc.library V7 and its history file to this
                  archive (directory 'v7')

 2. 8.97        - Bug fixed: On PPC-Systems with CPU clocks between
                  250-300 Mhz, the CPU clock returned by 'GetInfo' could
                  have been wrong.
                - Bug fixed: 'GetInfo' returned a wrong page table size.
                - Improved the accuracy of the FP conversion in the crash
                  requester which is used to display the FP registers as
                  ASCII string.

19. 8.97        - On some systems with small gfx address space, the gfx
                  RAM was not placed into BAT registers. Now the powerpc.
                  library tries to find out, where the gfx RAM is located
                  (using cybergraphics.library) and puts the gfx RAM into
                  BAT registers if possible (alignment must still be
                  properly set).
                - New environment variable 'gfxaddr' allows to specify an
                  address (either with or without $) to give the powerpc.
                  library a hint, where the gfx RAM should be.
                - New versions of cybermand and voxelspace added.
                - V11.3

27. 8.97        - Removed Gfx-RAM autodetection (seems to be somewhat risky)
                - Forgot to add warp.library 1.2 to the WarpOS-Archive.
                  powerpc.library V11.3 didn't work at all...
                  -> warp.library V1.2 added

15. 9.97        - CyberstormPPC support added.
                  WarpOS *WORKS* with the CyberStormPPC-Boards !! Cybermand
                  is now 12-13 times faster on 604E/200 relative to 68060/50.
                - Added new version of voxelspace to the archive. Added
                  special optimization for PPC604E.
                - Added voxel.readme and voxel_english.readme to the demos
                  drawer. This file contains some notes about the usage of
                  the voxelspace parameters and known problems.
                - Added english translations of WarpOS.guide and GameDev.guide.

16. 9.97        - Added a correction stage at CPU-clock calculation (in
                  function 'GetInfo'). The cpu clock is now displayed
                  completely correctly.

17. 9.97        - Problems with PPC-Enforcer and 604E fixed (NEVER use
                  self modifying code yourself!). One 'sync'-instruction
                  more, and everything works fine.

18. 9.97        - New library functions GetSysTimePPC, AddTimePPC, SubTimePPC
                  and CmpTimePPC for time measurement (also available vor V7)
                - New small demo program 'pixelOmania' to measure the
                  context switch performance (i.e. to compare V7 and V8+)

20. 9.97        - Added the 'WarpRace' application to the archive (drawer
                  'WarpRace'). This application is a modular performance
                  test program. Included are several modules and module
                  sources.
                  WarpRace and all modules so far work with powerpc.library V7.

21. 9.97        - Added the 'landscape' demo to the archive (drawer
                  'demos/landscape'), a fractal landscape generator.
                - Added new versions of 'tabletennis' and 'cyberpi' which
                  don't crash anymore if the powerpc.library can't be opened.
                  'Cyberpi' now supports both CPU's (new parameter M68K).
                - V12.0

25. 9.97        - Corrected a bug in the warprace executable (CTRL-C only
                  breaked the current recursion level)
                - Corrected a bug in warprace module 'Landscape.wrm' (mem
                  allocation was broken)
                - New 68K library function 'GetPPCState' allows to get
                  information about the state of the PPC and of PPC
                  applications (officially available in V13)
                - New tool PPCState displays the result of 'GetPPCState'
                - V12.1

27. 9.97        - New env-variable 'noPPC'. If this variable is 1, then
                  the powerpc.library always returns 0 at initialization.
                  This allows to use applications, which try to open
                  the powerpc.library, without PPC boards (before, WarpOS
                  simply crashed) if it supports the 68K too.

29. 9.97        - Static board detection implemented. If problems occur or
                  the 68060.library of the PowerUp-Distribution is not
                  installed, the board type can be selected using the new
                  env variable 'boardtype'.
                  0  =  auto detection using 68060.library
                  1  =  developer board
                  2  =  CyberstormPPC
                - New env variable 'earlyterm' implemented (also for V7).
                  If the variable is not 0, then the mirror task of a 68k
                  task is removed at the last CloseLibrary of the 68k task,
                  instead at removal of the task.
                  Hope, this will fix the problems with WShell.
                  The tools stackppc and changemmu DON'T work with earlyterm=1!
                  Use the 68K command stack to modify the PPC stack (the PPC
                  stack is about double the size of the 68K stack).
                - 12.2

 8.10.97        - RunPPC now interprets the PP_OFFSET field in the same way as
                  Run68K does. If PP_OFFSET is zero, than it works as before,
                  if it is not zero, a PPC library call is performed with the
                  base in PP_CODE and the library vector offset in PP_OFFSET.
                - Description and prototypes of SetExcMMU and ClearExcMMU were
                  missing. Corrected.
                - Bug fixed: FreeXMsgPPC trashed r2.
                - Inter-CPU messages can now be sent asynchronely, so they
                  may not be answered anymore by the foreign task. But it is
                  really important, that the processor frees the message which
                  allocated it (even if it is another task).
                - Exec/Replymsg now doesn't crash anymore, when called with
                  an InterCPU-msg without ReplyPort (but don't call exec/
                  ReplyMsg nevertheless without ReplyPort, why should you?).
                  Exec/ReplyMsg now simply does nothing in this case.
                - New library function SetReplyPortPPC allows to exchange the
                  reply port of a message (internal PPC message or InterCPU
                  message). Officially available in V13.
                - Added support of fields TC_SWITCH and TC_LAUNCH in the
                  exec task structure. If the appropriate bits in TC_FLAGS
                  are set, these functions are called whenever a PPC task
                  looses resp. gets the CPU (equal behaviour like exec).
                - New library functions 'SnoopTask' and 'EndSnoopTask'
                  allows to monitor the beginning and the end of a PPC task
                  (useful for debuggers). Officially available in V13.
                - V12.3

13.10.97        - Voxelspace 1.5 added. Window mode is now supported
                  (only for gfx boards).
                - Cybermand 1.2 added. Window mode is now supported
                  (also for PAL)

14.10.97        - Landscape 1.1 added. Window mode is now supported
                  (also for PAL)

15.10.97        - Corrected clib/powerpc_protos.h (was very buggy)

16.10.97        - Time Measurement was UNRELIABLE! Busclock could have
                  been measured wrong. Corrected (once again, one 'sync'
                  more...)
                - ChangeMMU was not correct. IBAT2 and DBAT2 were
                  exchanged.

22.10.97        - Bug fixed: FP-Registers f9-f13 were passed incorrectly
                  to custom exception handlers.

28.10.97        - Major internal change: all board specific stuff is
                  moved from powerpc.library to warp.library. The
                  powerpc.library is now completely board-independent
                  and will work unmodified with all PPC boards.

                  The warp.library has now become a real HAL, since
                  it now also provides access to board specific
                  resources using a standardized interface.

                  IMPORTANT NOTE: The powerpc.library V12.4 and higher
                  requires the warp.library V2 to be installed!!
                - Some bugfixes, which maybe could be responsible
                  for some deadlocks in rare cases.
                - V12.4

 6.11.97        - Minor changes in powerpc/powerpc.i (macros RUNPOWERPC
                  and RUNPOWERPC_XL) to avoid linker warnings.

 8.11.97        - Bug in clib/powerpc_protos.h fixed. The snoop functions
                  were enabled for V7 by mistake.
                - V13.0

22.11.97        - Oh, DAMN. Exec tasks couldn't use RunPPC because of
                  DOS calls. These calls are now handled by a new
                  support process called 'Babylon5'.
                - V13.1

25.11.97        - Some 'sync' instructions added to warp.library (maybe
                  this can solve some problems with PPC crashes). V2.1

26.11.97        - The powerpc.library returns now 0, if ppc.library is
                  active and if someone tries to open the powerpc.library.

27.11.97        - Bugs fixed in pragma/powerpc_lib.h: SPrintF was written
                  instead of SPrintF68K, and GetPPCState was enabled for
                  V7, by mistake.

 1.12.97        - NOTE: it is possible, that a PPC application crashes,
                  if it launches WarpOS (that means, if it is the first
                  PPC application) AND if SnoopDos is monitoring
                  exec/OpenLibrary. The crash seems to happen in the
                  Patch of SnoopDos. Run a PPC program earlier or avoid
                  monitoring exec/OpenLibrary with SnoopDos to avoid
                  these problems!

16.12.97        - New version of voxelspace added. It now supports
                  OS3.0 multibuffering with P96 -> No flickering anymore!
                  Use 'TURBOGFX' or 'WARP' as CLI parameter to switch
                  on multibuffering.
                - V13.2
